/* USER CODE BEGIN Header */
/**
  * @brief  Function implementing the defaultTask thread.
  * @param  argument: Not used 
  * @retval None
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "cmsis_os.h"
#include "mbedtls.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "stdint.h"
#include "string.h"
#include "ltdc.h"
#include "MT48LC4M32B2.h"
#include "fonts.h"
#include "lwip.h"
#include "lwip/opt.h"
#include "lwip/arch.h"
#include "lwip/api.h"
#include "lwip/inet.h"
#include "lwip/sockets.h"
#include "lwip/apps/fs.h"
#include "mbedtls/sha1.h"
#include "mbedtls/base64.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

DMA2D_HandleTypeDef hdma2d;

LTDC_HandleTypeDef hltdc;

RNG_HandleTypeDef hrng;

UART_HandleTypeDef huart1;

SDRAM_HandleTypeDef hsdram1;

osThreadId defaultTaskHandle;
osThreadId taskStringOutHandle;
/* USER CODE BEGIN PV */
/* Private variables ---------------------------------------------------------*/
#define LCD_FRAME_BUFFER SDRAM_DEVICE_ADDR
#define MAIL_SIZE (uint32_t) 5
#define QUEUE_SIZE (uint32_t) 1
osThreadId ThreadTCPHandle;
char guid_str[] = {"258EAFA5-E914-47DA-95CA-C5AB0DC85B11"};
unsigned char hash[20] = {0};
char str_buf[1000]={'\0'};
char str_usart[512] = {};
char str_out[32] = {};
char str_buf1[30] = {};
char str_buf2[256] = {};
uint8_t send_ws_buf[1312] = {0};
unsigned char *out_buffer;
osMailQId strout_Queue;
osMessageQId send_type_Queue;
typedef struct struct_sock_t {
  uint16_t y_pos;
  uint16_t port;
} struct_sock;
typedef struct struct_send_socket_t {
  int sock;
  uint16_t y_pos;
} struct_send_socket;
struct_send_socket send_socket01;
typedef struct struct_out_t {
  uint32_t tick_count;
  uint16_t x_pos;
  uint16_t y_pos;
  sFONT sfont;
  char str[60];
} struct_out;
struct_sock sock01;
static __attribute__ ((used,section(".user_heap_stack"))) uint8_t heap_sram1[32*1024];
uint8_t heap_sram2[32*1024];
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MPU_Config(void);
static void MX_GPIO_Init(void);
static void MX_LTDC_Init(void);
static void MX_FMC_Init(void);
static void MX_DMA2D_Init(void);
static void MX_USART1_UART_Init(void);
static void MX_RNG_Init(void);
void StartDefaultTask(void const * argument);
void TaskStringOut(void const * argument);

/* USER CODE BEGIN PFP */
/* Private function prototypes -----------------------------------------------*/
void TaskStringOut(void const * argument);
/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */
  HeapRegion_t xHeapRegions[] =
  {
      {  heap_sram1, sizeof(heap_sram1) },
      {  heap_sram2, sizeof(heap_sram2) },
      { NULL, 0 }
  };
  vPortDefineHeapRegions( xHeapRegions );
  /* USER CODE END 1 */

  /* MPU Configuration--------------------------------------------------------*/
  MPU_Config();

  /* Enable I-Cache---------------------------------------------------------*/
  SCB_EnableICache();

  /* Enable D-Cache---------------------------------------------------------*/
  SCB_EnableDCache();

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_LTDC_Init();
  MX_FMC_Init();
  MX_DMA2D_Init();
  MX_USART1_UART_Init();
  MX_RNG_Init();
  /* USER CODE BEGIN 2 */
  MT48LC4M32B2_init(&hsdram1);
  HAL_LTDC_SetAddress(&hltdc,LCD_FRAME_BUFFER,0);
  TFT_FillScreen(LCD_COLOR_BLACK);
  TFT_SetFont(&Font24);
  TFT_SetTextColor(LCD_COLOR_LIGHTGREEN);
  TFT_DisplayString(0, 10, (uint8_t *)"WebSocket Server", CENTER_MODE);
  /* USER CODE END 2 */

  /* USER CODE BEGIN RTOS_MUTEX */
  /* add mutexes, ... */
  /* USER CODE END RTOS_MUTEX */

  /* USER CODE BEGIN RTOS_SEMAPHORES */
  /* add semaphores, ... */
  /* USER CODE END RTOS_SEMAPHORES */

  /* USER CODE BEGIN RTOS_TIMERS */
  /* start timers, add new ones, ... */
  /* USER CODE END RTOS_TIMERS */

  /* Create the thread(s) */
  /* definition and creation of defaultTask */
  osThreadDef(defaultTask, StartDefaultTask, osPriorityNormal, 0, 1024);
  defaultTaskHandle = osThreadCreate(osThread(defaultTask), NULL);

  /* definition and creation of taskStringOut */
  osThreadDef(taskStringOut, TaskStringOut, osPriorityBelowNormal, 0, 512);
  taskStringOutHandle = osThreadCreate(osThread(taskStringOut), NULL);

  /* USER CODE BEGIN RTOS_THREADS */
  /* add threads, ... */

  /* USER CODE END RTOS_THREADS */

  /* USER CODE BEGIN RTOS_QUEUES */
  /* add queues, ... */
  osMailQDef(stroutqueue, MAIL_SIZE, struct_out);
  strout_Queue = osMailCreate(osMailQ(stroutqueue), NULL);
  osMessageQDef(send_type_Queue, QUEUE_SIZE, uint16_t);
  send_type_Queue = osMessageCreate(osMessageQ(send_type_Queue), NULL);
  /* USER CODE END RTOS_QUEUES */
 

  /* Start scheduler */
  osKernelStart();
  
  /* We should never get here as control is now taken by the scheduler */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */

  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};
  RCC_PeriphCLKInitTypeDef PeriphClkInitStruct = {0};

  /**Configure the main internal regulator output voltage 
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);
  /**Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 25;
  RCC_OscInitStruct.PLL.PLLN = 400;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 2;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /**Activate the Over-Drive mode 
  */
  if (HAL_PWREx_EnableOverDrive() != HAL_OK)
  {
    Error_Handler();
  }
  /**Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV4;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV2;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_6) != HAL_OK)
  {
    Error_Handler();
  }
  PeriphClkInitStruct.PeriphClockSelection = RCC_PERIPHCLK_LTDC|RCC_PERIPHCLK_USART1
                              |RCC_PERIPHCLK_CLK48;
  PeriphClkInitStruct.PLLSAI.PLLSAIN = 192;
  PeriphClkInitStruct.PLLSAI.PLLSAIR = 3;
  PeriphClkInitStruct.PLLSAI.PLLSAIQ = 2;
  PeriphClkInitStruct.PLLSAI.PLLSAIP = RCC_PLLSAIP_DIV4;
  PeriphClkInitStruct.PLLSAIDivQ = 1;
  PeriphClkInitStruct.PLLSAIDivR = RCC_PLLSAIDIVR_4;
  PeriphClkInitStruct.Usart1ClockSelection = RCC_USART1CLKSOURCE_PCLK2;
  PeriphClkInitStruct.Clk48ClockSelection = RCC_CLK48SOURCE_PLLSAIP;
  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief DMA2D Initialization Function
  * @param None
  * @retval None
  */
static void MX_DMA2D_Init(void)
{

  /* USER CODE BEGIN DMA2D_Init 0 */

  /* USER CODE END DMA2D_Init 0 */

  /* USER CODE BEGIN DMA2D_Init 1 */

  /* USER CODE END DMA2D_Init 1 */
  hdma2d.Instance = DMA2D;
  hdma2d.Init.Mode = DMA2D_M2M_BLEND;
  hdma2d.Init.ColorMode = DMA2D_OUTPUT_ARGB8888;
  hdma2d.Init.OutputOffset = 0;
  hdma2d.LayerCfg[1].InputOffset = 0;
  hdma2d.LayerCfg[1].InputColorMode = DMA2D_INPUT_ARGB8888;
  hdma2d.LayerCfg[1].AlphaMode = DMA2D_REPLACE_ALPHA;
  hdma2d.LayerCfg[1].InputAlpha = 0;
  hdma2d.LayerCfg[0].InputOffset = 0;
  hdma2d.LayerCfg[0].InputColorMode = DMA2D_INPUT_ARGB8888;
  hdma2d.LayerCfg[0].AlphaMode = DMA2D_REPLACE_ALPHA;
  hdma2d.LayerCfg[0].InputAlpha = 0;
  hdma2d.LayerCfg[0].AlphaInverted = DMA2D_REGULAR_ALPHA;
  hdma2d.LayerCfg[0].RedBlueSwap = DMA2D_RB_REGULAR;
  if (HAL_DMA2D_Init(&hdma2d) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_DMA2D_ConfigLayer(&hdma2d, 0) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_DMA2D_ConfigLayer(&hdma2d, 1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN DMA2D_Init 2 */

  /* USER CODE END DMA2D_Init 2 */

}

/**
  * @brief LTDC Initialization Function
  * @param None
  * @retval None
  */
static void MX_LTDC_Init(void)
{

  /* USER CODE BEGIN LTDC_Init 0 */

  /* USER CODE END LTDC_Init 0 */

  LTDC_LayerCfgTypeDef pLayerCfg = {0};

  /* USER CODE BEGIN LTDC_Init 1 */

  /* USER CODE END LTDC_Init 1 */
  hltdc.Instance = LTDC;
  hltdc.Init.HSPolarity = LTDC_HSPOLARITY_AL;
  hltdc.Init.VSPolarity = LTDC_VSPOLARITY_AL;
  hltdc.Init.DEPolarity = LTDC_DEPOLARITY_AL;
  hltdc.Init.PCPolarity = LTDC_PCPOLARITY_IPC;
  hltdc.Init.HorizontalSync = 40;
  hltdc.Init.VerticalSync = 9;
  hltdc.Init.AccumulatedHBP = 53;
  hltdc.Init.AccumulatedVBP = 11;
  hltdc.Init.AccumulatedActiveW = 533;
  hltdc.Init.AccumulatedActiveH = 283;
  hltdc.Init.TotalWidth = 565;
  hltdc.Init.TotalHeigh = 285;
  hltdc.Init.Backcolor.Blue = 0;
  hltdc.Init.Backcolor.Green = 0;
  hltdc.Init.Backcolor.Red = 0;
  if (HAL_LTDC_Init(&hltdc) != HAL_OK)
  {
    Error_Handler();
  }
  pLayerCfg.WindowX0 = 0;
  pLayerCfg.WindowX1 = 480;
  pLayerCfg.WindowY0 = 0;
  pLayerCfg.WindowY1 = 272;
  pLayerCfg.PixelFormat = LTDC_PIXEL_FORMAT_ARGB8888;
  pLayerCfg.Alpha = 255;
  pLayerCfg.Alpha0 = 0;
  pLayerCfg.BlendingFactor1 = LTDC_BLENDING_FACTOR1_PAxCA;
  pLayerCfg.BlendingFactor2 = LTDC_BLENDING_FACTOR2_PAxCA;
  pLayerCfg.FBStartAdress = 0;
  pLayerCfg.ImageWidth = 480;
  pLayerCfg.ImageHeight = 272;
  pLayerCfg.Backcolor.Blue = 0;
  pLayerCfg.Backcolor.Green = 0;
  pLayerCfg.Backcolor.Red = 0;
  if (HAL_LTDC_ConfigLayer(&hltdc, &pLayerCfg, 0) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN LTDC_Init 2 */

  /* USER CODE END LTDC_Init 2 */

}

/**
  * @brief RNG Initialization Function
  * @param None
  * @retval None
  */
static void MX_RNG_Init(void)
{

  /* USER CODE BEGIN RNG_Init 0 */

  /* USER CODE END RNG_Init 0 */

  /* USER CODE BEGIN RNG_Init 1 */

  /* USER CODE END RNG_Init 1 */
  hrng.Instance = RNG;
  if (HAL_RNG_Init(&hrng) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN RNG_Init 2 */

  /* USER CODE END RNG_Init 2 */

}

/**
  * @brief USART1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART1_UART_Init(void)
{

  /* USER CODE BEGIN USART1_Init 0 */

  /* USER CODE END USART1_Init 0 */

  /* USER CODE BEGIN USART1_Init 1 */

  /* USER CODE END USART1_Init 1 */
  huart1.Instance = USART1;
  huart1.Init.BaudRate = 115200;
  huart1.Init.WordLength = UART_WORDLENGTH_8B;
  huart1.Init.StopBits = UART_STOPBITS_1;
  huart1.Init.Parity = UART_PARITY_NONE;
  huart1.Init.Mode = UART_MODE_TX_RX;
  huart1.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart1.Init.OverSampling = UART_OVERSAMPLING_16;
  huart1.Init.OneBitSampling = UART_ONE_BIT_SAMPLE_DISABLE;
  huart1.AdvancedInit.AdvFeatureInit = UART_ADVFEATURE_NO_INIT;
  if (HAL_UART_Init(&huart1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART1_Init 2 */

  /* USER CODE END USART1_Init 2 */

}

/* FMC initialization function */
static void MX_FMC_Init(void)
{
  FMC_SDRAM_TimingTypeDef SdramTiming;

  /** Perform the SDRAM1 memory initialization sequence
  */
  hsdram1.Instance = FMC_SDRAM_DEVICE;
  /* hsdram1.Init */
  hsdram1.Init.SDBank = FMC_SDRAM_BANK1;
  hsdram1.Init.ColumnBitsNumber = FMC_SDRAM_COLUMN_BITS_NUM_8;
  hsdram1.Init.RowBitsNumber = FMC_SDRAM_ROW_BITS_NUM_12;
  hsdram1.Init.MemoryDataWidth = FMC_SDRAM_MEM_BUS_WIDTH_16;
  hsdram1.Init.InternalBankNumber = FMC_SDRAM_INTERN_BANKS_NUM_4;
  hsdram1.Init.CASLatency = FMC_SDRAM_CAS_LATENCY_2;
  hsdram1.Init.WriteProtection = FMC_SDRAM_WRITE_PROTECTION_DISABLE;
  hsdram1.Init.SDClockPeriod = FMC_SDRAM_CLOCK_PERIOD_2;
  hsdram1.Init.ReadBurst = FMC_SDRAM_RBURST_ENABLE;
  hsdram1.Init.ReadPipeDelay = FMC_SDRAM_RPIPE_DELAY_0;
  /* SdramTiming */
  SdramTiming.LoadToActiveDelay = 2;
  SdramTiming.ExitSelfRefreshDelay = 6;
  SdramTiming.SelfRefreshTime = 4;
  SdramTiming.RowCycleDelay = 6;
  SdramTiming.WriteRecoveryTime = 2;
  SdramTiming.RPDelay = 2;
  SdramTiming.RCDDelay = 2;

  if (HAL_SDRAM_Init(&hsdram1, &SdramTiming) != HAL_OK)
  {
    Error_Handler( );
  }

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOE_CLK_ENABLE();
  __HAL_RCC_GPIOG_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();
  __HAL_RCC_GPIOJ_CLK_ENABLE();
  __HAL_RCC_GPIOD_CLK_ENABLE();
  __HAL_RCC_GPIOK_CLK_ENABLE();
  __HAL_RCC_GPIOF_CLK_ENABLE();
  __HAL_RCC_GPIOI_CLK_ENABLE();
  __HAL_RCC_GPIOH_CLK_ENABLE();
  __HAL_RCC_GPIOC_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOK, GPIO_PIN_3, GPIO_PIN_SET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOI, GPIO_PIN_1, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOI, GPIO_PIN_12, GPIO_PIN_SET);

  /*Configure GPIO pin : PK3 */
  GPIO_InitStruct.Pin = GPIO_PIN_3;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  HAL_GPIO_Init(GPIOK, &GPIO_InitStruct);

  /*Configure GPIO pin : PI1 */
  GPIO_InitStruct.Pin = GPIO_PIN_1;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOI, &GPIO_InitStruct);

  /*Configure GPIO pin : PI12 */
  GPIO_InitStruct.Pin = GPIO_PIN_12;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  HAL_GPIO_Init(GPIOI, &GPIO_InitStruct);

}

/* USER CODE BEGIN 4 */
//---------------------------------------------------------------
void StrSort (char* str)
{
  typedef struct strarray{
    char data[20][50];
  } strarray_ptr;
  char *str_tmp = (void*) str;
  char *istr;
  int cnt = 0, cnt_pass=0, res = 0, i, j;
  uint32_t itemsize;
  strarray_ptr *strarray1 = (void*) str_buf;
  //copy to array
  while(1)
  {
     istr = strstr(str_tmp,"\r\n");
     itemsize = istr - str_tmp;
     if((itemsize>10)&&(itemsize<100))
     {
        strncpy(strarray1->data[cnt],str_tmp,itemsize+2);
        strarray1->data[cnt][itemsize+2] = 0;
        str_tmp+=itemsize+2;
     }
     else
     {
        break;
     }
     cnt++;
  }
  //sort
  cnt_pass=cnt;
  for(j=0;j<(cnt-1);j++)
  {
     for(i=0;i<(cnt_pass-1);i++)
     {
        res = strcmp (strarray1->data[i], strarray1->data[i+1]);
        if (res>0)
        {
           //swap
           strcpy (strarray1->data[cnt],strarray1->data[i+1]);
           strcpy (strarray1->data[i+1],strarray1->data[i]);
           strcpy (strarray1->data[i],strarray1->data[cnt]);
        }
     }
     cnt_pass--;
  }
  //copy from array
  str[0] = 0;
  for(i=0;i<cnt;i++)
  {
    if (i==0) strcpy (str,strarray1->data[i]);
    else strcat (str,strarray1->data[i]);
  }
  str_tmp[0] = 0;
}
//---------------------------------------------------------------
static void tcp_send(void *arg)
{
  osEvent event;
  struct_send_socket *arg_send_socket;
  arg_send_socket = (struct_send_socket*) arg;
  volatile uint16_t len = 0, type = 0;
  int i, val=0;
  char str1[60];
  for(;;)
  {
    event = osMessageGet(send_type_Queue, 100);
    if (event.status == osEventMessage)
    {
      type = event.value.v;
    }
    if((type==1)||(type==2))
    {
      if(type==1)
      {
        osThreadList(send_ws_buf);
        len = strlen((char*)send_ws_buf);
        send_ws_buf[0]=0x81;
      }
      else
      {
        send_ws_buf[0]=0x82;
        len = 1024;
        for(i=0;i<512;i++)
        {
          val = HAL_RNG_GetRandomNumber(&hrng)%4096;
          send_ws_buf[i * 2 + 4] = (uint8_t)val;
          send_ws_buf[i * 2 + 5] = (uint8_t)(val>>8);
        }
      }
      if(len<126)
      {
        osThreadList((uint8_t *)(send_ws_buf + 2));
        StrSort((char *)(send_ws_buf + 2));
        sprintf(str1, "%u",xPortGetMinimumEverFreeHeapSize());
        strcat((char *)(send_ws_buf + 2), str1);
        len = strlen((char*)(send_ws_buf + 2));
        send_ws_buf[1] = len;
        write(arg_send_socket->sock, send_ws_buf, len + 2);
      }
      else if((len<65536))
      {
        send_ws_buf[1] = 126;
        send_ws_buf[2] = (uint8_t)(len>>8);
        send_ws_buf[3] = (uint8_t)len;
        if(type==1)
        {
          osThreadList((uint8_t *)(send_ws_buf + 4));
          StrSort((char *)(send_ws_buf + 4));
        }
        write(arg_send_socket->sock, send_ws_buf, len + 4);
      }
    }
    osDelay(500);
  }
}
//---------------------------------------------------------------
static void tcp_thread(void *arg)
{
  struct_out *qstruct;
  int sock, accept_sock, ret;
  struct sockaddr_in address, remotehost;
  socklen_t sockaddrsize;
  int buflen = 1024;
  char buf[1024] = {};
  char *istr;
  size_t len;
  char str_msg = 0;
  if ((sock = socket(AF_INET,SOCK_STREAM, 0)) >= 0)
  {
    address.sin_family = AF_INET;
    address.sin_port = htons(8080);
    address.sin_addr.s_addr = INADDR_ANY;
    if (bind(sock, (struct sockaddr *)&address, sizeof (address)) ==  0)
    {
      listen(sock, 5);
      for(;;)
      {
        accept_sock = accept(sock, (struct sockaddr *)&remotehost, (socklen_t *)&sockaddrsize);
        if(accept_sock >= 0)
        {
          send_socket01.y_pos = 200;
          send_socket01.sock = accept_sock;
          ThreadTCPHandle = sys_thread_new("tcp_send", tcp_send, (void*)&send_socket01, DEFAULT_THREAD_STACKSIZE, osPriorityNormal );
          for(;;)
          {
            ret = recvfrom(accept_sock, buf, buflen, 0, (struct sockaddr *)&remotehost, &sockaddrsize);
            if(ret > 0)
            {
              if ((ret >=5) && (strncmp(buf, "GET /", 5) == 0))
              {
                //parse buf
                qstruct = osMailAlloc(strout_Queue, osWaitForever);
                qstruct->y_pos = 110;
                istr = strstr(buf,"Sec-WebSocket-Key:");
                istr[43] = 0;
                strcpy(str_buf1,istr+19);
                sprintf(qstruct->str,"%s", str_buf1);
                osMailPut(strout_Queue, qstruct);
                osMailFree(strout_Queue, qstruct);
                strcpy(str_buf,"HTTP/1.1 101 Switching Protocols\r\n");
                strcat(str_buf,"Upgrade: websocket\r\n");
                strcat(str_buf,"Connection: Upgrade\r\n");
                strcat(str_buf,"Sec-WebSocket-Accept: ");
                sprintf(str_usart,"%s%s", istr+19,guid_str);
                mbedtls_sha1((unsigned char *)str_usart, 60, hash);
                mbedtls_base64_encode( (unsigned char *)str_buf2, 100, &len, hash, 20);
                str_buf2[len] = 0;
                strcat(str_buf,(char*)str_buf2);
                strcat(str_buf,"\r\n\r\n");
                write(accept_sock, (const unsigned char*)(str_buf), strlen(str_buf));
              }
              else if((ret >1) && ( (buf[0]&0x0F) == 0x08))
              {
                buf[0] = 0x88;
                buf[1] = 0x00;
                write(accept_sock, (const unsigned char*)buf, 2);
                close(accept_sock);
                break;
              }
              else if((ret >1) && (buf[0] == 0x81))
              {
                //mask
                if(buf[1]>>7)  str_msg=buf[6]^buf[2];
                else str_msg=buf[2];
                if(str_msg=='1')
                {
                  osMessagePut(send_type_Queue, 1, 100);
                }
                else if(str_msg=='2')
                {
                  osMessagePut(send_type_Queue, 2, 100);
                }
                else if(str_msg=='3')
                {
                  osMessagePut(send_type_Queue, 3, 100);
                }
                else if(str_msg=='4')
                {
                  osMessagePut(send_type_Queue, 4, 100);
                }
              }
            }
            else
            {
              close(accept_sock);
              break;
            }
          }
        }
        osThreadTerminate(ThreadTCPHandle);
      }
    }
    else
    {
      close(sock);
      return;
    }
  }
}
//---------------------------------------------------------------
static void http_thread(void *arg)
{
  struct_sock *arg_sock;
  struct_out *qstruct[4];
  int sock, accept_sock, ret;
  int buflen = 512;
  char buf[512] = {};
  struct fs_file file;
  struct sockaddr_in address, remotehost;
  socklen_t sockaddrsize;
  arg_sock = (struct_sock*) arg;
  if ((sock = socket(AF_INET,SOCK_STREAM, 0)) >= 0)
  {
    address.sin_family = AF_INET;
    address.sin_port = htons(arg_sock->port);
    address.sin_addr.s_addr = INADDR_ANY;
    if (bind(sock, (struct sockaddr *)&address, sizeof (address)) ==  0)
    {
    	sys_thread_new("tcp_thread", tcp_thread, NULL, DEFAULT_THREAD_STACKSIZE*2, osPriorityNormal );
    	listen(sock, 5);
      for(;;)
      {
        accept_sock = accept(sock, (struct sockaddr *)&remotehost, (socklen_t *)&sockaddrsize);
        if(accept_sock >= 0)
        {
          ret = recvfrom(accept_sock, buf, buflen, 0, (struct sockaddr *)&remotehost, &sockaddrsize);
          if(ret > 0)
          {
            if ((ret >=5) && (strncmp(buf, "GET /", 5) == 0))
            {
              qstruct[0] = osMailAlloc(strout_Queue, osWaitForever);
              qstruct[0]->y_pos = 250;
              qstruct[0]->x_pos = 10;
              qstruct[0]->sfont = Font24;
              sprintf(qstruct[0]->str,"%-20s", "Connect");
              osMailPut(strout_Queue, qstruct[0]);
              osMailPut(strout_Queue, qstruct[0]);
              if ((strncmp((char const *)buf,"GET / ",6)==0)||(strncmp((char const *)buf,"GET /index.html",15)==0))
              {
                fs_open(&file, "/index.html");
                write(accept_sock, (const unsigned char*)(file.data), (size_t)file.len);
                fs_close(&file);
              }
              else if (strncmp((char const *)buf,"GET /favicon.ico",16)==0)
              {
                fs_open(&file, "/favicon.ico");
                write(accept_sock, (const unsigned char*)(file.data), (size_t)file.len);
                fs_close(&file);
              }
              else if (strncmp((char const *)buf,"GET /js/Chart.min.js",20)==0)
              {
                fs_open(&file, "/js/Chart.min.js");
                write(accept_sock, (const unsigned char*)(file.data), (size_t)file.len);
                fs_close(&file);
              }
              else
              {
                fs_open(&file, "/404.html");
                write(accept_sock, (const unsigned char*)(file.data), (size_t)file.len);
                fs_close(&file);
                qstruct[1] = osMailAlloc(strout_Queue, osWaitForever);
                qstruct[1]->y_pos = arg_sock->y_pos + 40;
                qstruct[1]->x_pos = 10;
                qstruct[1]->sfont = Font24;
                sprintf(qstruct[1]->str,"%-20s", "file not found");
                osMailPut(strout_Queue, qstruct[1]);
              }
              if ((ret >=20)) buf[20] = 0;
              else buf[ret] = 0;
              qstruct[2] = osMailAlloc(strout_Queue, osWaitForever);
              qstruct[2]->y_pos = arg_sock->y_pos;
              qstruct[2]->x_pos = 10;
              qstruct[2]->sfont = Font24;
              sprintf(qstruct[2]->str,"%-20s", buf);
              osMailPut(strout_Queue, qstruct[2]);
              qstruct[3] = osMailAlloc(strout_Queue, osWaitForever);
              qstruct[3]->y_pos = arg_sock->y_pos + 80;
              qstruct[3]->x_pos = 10;
              qstruct[3]->sfont = Font24;
              sprintf(qstruct[3]->str,"%7u",xPortGetMinimumEverFreeHeapSize());
              osMailPut(strout_Queue, qstruct[3]);
            }
          }
          close(accept_sock);
        }
      }
    }
    else
    {
      close(sock);
      return;
    }
  }
}
//---------------------------------------------------------------
/* USER CODE END 4 */

/* USER CODE BEGIN Header_StartDefaultTask */
/**
  * @brief  Function implementing the defaultTask thread.
  * @param  argument: Not used 
  * @retval None
  */
/* USER CODE END Header_StartDefaultTask */
void StartDefaultTask(void const * argument)
{
  /* MX_LWIP_Init() is generated within mbedtls_net_init() function in net_cockets.c file */
  /* Up to user to call mbedtls_net_init() function in MBEDTLS initialization step */

  /* Up to user define the empty MX_MBEDTLS_Init() function located in mbedtls.c file */
  MX_MBEDTLS_Init();

  /* USER CODE BEGIN 5 */
  MX_LWIP_Init();
  TFT_SetTextColor(LCD_COLOR_LIGHTBLUE);
  sock01.port = 80;
  sock01.y_pos = 60;
  sys_thread_new("http_thread", http_thread, (void*)&sock01, DEFAULT_THREAD_STACKSIZE * 4, osPriorityNormal);
  /* Infinite loop */
  for(;;)
  {
    osDelay(1);
  }
  /* USER CODE END 5 */ 
}

/* USER CODE BEGIN Header_TaskStringOut */
/**
* @brief Function implementing the taskStringOut thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_TaskStringOut */
void TaskStringOut(void const * argument)
{
  /* USER CODE BEGIN TaskStringOut */
  osEvent event;
  struct_out *qstruct;
  /* Infinite loop */
  for(;;)
  {
    event = osMailGet(strout_Queue, osWaitForever);
    if (event.status == osEventMail)
    {
      qstruct = event.value.p;
      TFT_SetFont(&qstruct->sfont);
      sprintf(str_out,"%s", qstruct->str);
      TFT_DisplayString(qstruct->x_pos, qstruct->y_pos, (uint8_t *)str_out, LEFT_MODE);
      osMailFree(strout_Queue, qstruct);
    }
  }
  /* USER CODE END TaskStringOut */
}

/* MPU Configuration */

void MPU_Config(void)
{
  MPU_Region_InitTypeDef MPU_InitStruct = {0};

  /* Disables the MPU */
  HAL_MPU_Disable();
  /**Initializes and configures the Region and the memory to be protected 
  */
  MPU_InitStruct.Enable = MPU_REGION_ENABLE;
  MPU_InitStruct.Number = MPU_REGION_NUMBER0;
  MPU_InitStruct.BaseAddress = 0xC0000000;
  MPU_InitStruct.Size = MPU_REGION_SIZE_4MB;
  MPU_InitStruct.SubRegionDisable = 0x0;
  MPU_InitStruct.TypeExtField = MPU_TEX_LEVEL0;
  MPU_InitStruct.AccessPermission = MPU_REGION_FULL_ACCESS;
  MPU_InitStruct.DisableExec = MPU_INSTRUCTION_ACCESS_ENABLE;
  MPU_InitStruct.IsShareable = MPU_ACCESS_NOT_SHAREABLE;
  MPU_InitStruct.IsCacheable = MPU_ACCESS_CACHEABLE;
  MPU_InitStruct.IsBufferable = MPU_ACCESS_NOT_BUFFERABLE;

  HAL_MPU_ConfigRegion(&MPU_InitStruct);
  /**Initializes and configures the Region and the memory to be protected 
  */
  MPU_InitStruct.Enable = MPU_REGION_ENABLE;
  MPU_InitStruct.Number = MPU_REGION_NUMBER1;
  MPU_InitStruct.BaseAddress = 0xC0400000;
  MPU_InitStruct.Size = MPU_REGION_SIZE_4MB;
  MPU_InitStruct.SubRegionDisable = 0x0;
  MPU_InitStruct.TypeExtField = MPU_TEX_LEVEL0;
  MPU_InitStruct.AccessPermission = MPU_REGION_FULL_ACCESS;
  MPU_InitStruct.DisableExec = MPU_INSTRUCTION_ACCESS_ENABLE;
  MPU_InitStruct.IsShareable = MPU_ACCESS_SHAREABLE;
  MPU_InitStruct.IsCacheable = MPU_ACCESS_CACHEABLE;
  MPU_InitStruct.IsBufferable = MPU_ACCESS_BUFFERABLE;

  HAL_MPU_ConfigRegion(&MPU_InitStruct);
  /* Enables the MPU */
  HAL_MPU_Enable(MPU_PRIVILEGED_DEFAULT);

}
/**
  * @brief  Period elapsed callback in non blocking mode
  * @note   This function is called  when TIM1 interrupt took place, inside
  * HAL_TIM_IRQHandler(). It makes a direct call to HAL_IncTick() to increment
  * a global variable "uwTick" used as application time base.
  * @param  htim : TIM handle
  * @retval None
  */
void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim)
{
  /* USER CODE BEGIN Callback 0 */

  /* USER CODE END Callback 0 */
  if (htim->Instance == TIM1) {
    HAL_IncTick();
  }
  /* USER CODE BEGIN Callback 1 */

  /* USER CODE END Callback 1 */
}

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  while(1) 
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
    ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
